#include "bits/stdc++.h"

using namespace std;

// Maksymalna liczba, o którą może pojawić się zapytanie.
const long long LIMIT = 5000000000LL;

// Funkcja f zdefiniowana w zadaniu - zwraca sumę cyfr liczby n.
int f(long long n) {
  // Deklarujemy zmienną na sumę.
  int suma = 0;
  // Dopóki liczba n nie jest równa zero,
  while (n != 0) {
    // dodaj do sumy ostatnią cyfrę (resztę z dzielenie przez 10)
    suma += n % 10;
    // i usuń tę cyfrę (podziel tę liczbę przez 10).
    n /= 10;
  }
  // Na końcu zwróć sumę.
  return suma;
}

// Funkcja g zdefniowana w zadaniu, zwraca n + f(n) * f(n).
long long g(long long n) {
  // Zapisujemy f(n) jako zmienną, aby nie liczyć tej funkcji dwukrotnie.
  int fn = f(n);
  // Zwracamy wartość funkcji g dla liczby n.
  return n + fn * fn;
}

int main() {
  // Deklarujemy i wczytujemy liczbę zapytań.
  int q;
  cin >> q;

  // Deklarujemy wektor na zapytania.
  // Zapytania będziemy trzymali jako parę określającą liczbę, o którą
  // pytamy, a także indeks zapytania (które to było zapytanie w kolejności).
  vector <pair <long long, int>> M(q);
  for (int i=0; i<q; i++) {
    long long m;
    cin >> m;
    M[i] = make_pair(m, i);
  }

  // Sortujemy wszystkie zapytania.
  sort(M.begin(), M.end());

  // Deklarujemy wektor na nasze odpowiedzi, które będziemy uzupełniać.
  // Początkowo wszystko jest ustawione na 0 (czyli fałsz).
  vector <bool> odpowiedz(q);

  // Zaczynamy od n = 1.
  long long n = 1;

  // Deklarujemy wskaźnik na wektor M, początkowo równy zero.
  int wsk_m = 0;

  // Dopóki n jest nie większe niż nasz limit:
  while (n <= LIMIT) {
    // Sprawdzamy czy aktualna wartość w wektorze M jest mniejsza od n.
    while (wsk_m < q and M[wsk_m].first < n) {
      // Jeżeli tak, to musimy przesunąć nasz wskaźnik w prawo.
      wsk_m++;
    }
    // Sprawdzamy teraz czy aktualna wartość w wektorze M jest równa n.
    while (wsk_m < q and M[wsk_m].first == n) {
      // Jeżeli tak, to daną wartość możemy uzyskać w procesie,
      // dlatego ustawiamy odpowiednią odpowiedź na true.
      odpowiedz[M[wsk_m].second] = true;
      // Następnie przesuwamy wskaźnik w prawo.
      wsk_m++;
    }
    // Zamieniamy n na g(n).
    n = g(n);
  }

  // Finalnie, dla wszystkich zapytań wypisujemy odpowiednie odpowiedzi.
  for (int i=0; i<q; i++) {
    if (odpowiedz[i]) cout << "TAK\n";
    else cout << "NIE\n";
  }
}
